package de.ivu.elect.presentation.benutzerverwaltung.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.benutzerverwaltung.BenutzerEinsatzortEditView;

@Named(BenutzerEinsatzortDeleteAction.COMPONENT_NAME)
public class BenutzerEinsatzortDeleteAction extends AbstractBenutzerEinsatzortAction {

  public static final String COMPONENT_NAME = "benutzerEinsatzortDeleteAction";

  private static final long serialVersionUID = 1L;

  @View
  @Inject
  private BenutzerEinsatzortEditView editView;

  public BenutzerEinsatzortDeleteAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.BENUTZER_EINSATZORT_DELETE;
  }

  @Override
  public boolean isDisabledInternal(@Nonnull BenutzerEinsatzort benutzerEinsatzort) {
    return benutzerEinsatzort.equals(principal.getBenutzerEinsatzort());
  }

  @Override
  protected String doIt(BenutzerEinsatzort benutzerEinsatzort) {
    editView.setEntity(benutzerEinsatzort);

    return null;
  }

  @Override
  protected boolean isFireChangeEvent() {
    return true;
  }

  @Override
  public String getDialogName() {
    return "DeleteConfirm";
  }

  @Override
  public String getLabelKey() {
    return "entity.edit.action.delete";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconDelete();
  }
}
